diff --git a/gcc/analyzer/region-model2.h b/gcc/analyzer/region-model2.h
index 9127c5ab9f3..a9bf778e2d3 100644
--- a/gcc/analyzer/region-model2.h
+++ b/gcc/analyzer/region-model2.h
@@ -1816,10 +1843,10 @@ class region_model2
 
   region2_id add_new_malloc_region2 ();
 #endif
-  region2 *create_region_for_heap_alloc (svalue2 *size_in_bytes);
-  region2 *create_region_for_alloca (svalue2 *size_in_bytes);
+  const region2 *create_region_for_heap_alloc (const svalue2 *size_in_bytes);
+  const region2 *create_region_for_alloca (const svalue2 *size_in_bytes);
 
-  tree get_representative_tree (svalue2 *sval) const;
+  tree get_representative_tree (const svalue2 *sval) const;
 #if 0
   path_var get_representative_path_var (region2_id rid) const;
   void get_path_vars_for_svalue2 (svalue2_id sid, vec<path_var> *out) const;
@@ -1879,11 +1906,11 @@ class region_model2
 				   struct append_ssa_names_cb_data *data);
 
  private:
-  region2 *get_lvalue_1 (path_var pv,
-			 region_model2_context *ctxt);
-  svalue2 *get_rvalue_1 (path_var pv,
-			 region_model2_context *ctxt);
-  svalue2 *get_store_value (region2 *reg);
+  const region2 *get_lvalue_1 (path_var pv,
+			       region_model2_context *ctxt);
+  const svalue2 *get_rvalue_1 (path_var pv,
+			       region_model2_context *ctxt);
+  const svalue2 *get_store_value (const region2 *reg);
 
 #if 0
   void copy_struct_region2 (region2_id dst_rid, struct_region2 *dst_reg,
@@ -1927,7 +1954,8 @@ class region_model2
 #endif
   void on_top_level_param (tree param, region_model2_context *ctxt);
 
-  void record_dynamic_extents (region2 *reg, svalue2 *size_in_bytes);
+  void record_dynamic_extents (const region2 *reg,
+			       const svalue2 *size_in_bytes);
 
   /* Storing this here to avoid passing it around everywhere.  */
   region_model2_manager *const m_mgr;
@@ -1936,7 +1964,7 @@ class region_model2
 
   constraint_manager2 *m_constraints2; // TODO: embed, rather than dynalloc?
 
-  frame_region2 *m_current_frame;
+  const frame_region2 *m_current_frame;
 };
 
 /* Some region_model2 activity could lead to warnings (e.g. attempts to use an
@@ -1973,7 +2001,7 @@ class region_model2_context
      MAP has already been applied to the IDs, but is provided in case
      the client needs to figure out the old IDs.  */
 #if 0
-  virtual int on_svalue2_purge (svalue2 *purged_value) = 0;
+  virtual int on_svalue2_purge (const svalue2 *purged_value) = 0;
 #endif
 
   virtual logger *get_logger () = 0;
@@ -2024,7 +2052,7 @@ class noop_region_model2_context : public region_model2_context
 public:
   void warn (pending_diagnostic *) OVERRIDE {}
 #if 0
-  int on_svalue2_purge (svalue2 *) OVERRIDE
+  int on_svalue2_purge (const svalue2 *) OVERRIDE
   {
     return 0;
   }
@@ -2205,7 +2233,7 @@ private:
 
 void assert_condition2 (const location &loc,
 			region_model2 &model,
-			svalue2 *lhs, tree_code op, svalue2 *rhs,
+			const svalue2 *lhs, tree_code op, const svalue2 *rhs,
 			tristate expected);
 
 void assert_condition2 (const location &loc,
diff --git a/gcc/analyzer/store2.cc b/gcc/analyzer/store2.cc
index 039177c6267..fa642219f25 100644
--- a/gcc/analyzer/store2.cc
+++ b/gcc/analyzer/store2.cc
@@ -68,7 +68,7 @@ namespace ana {
 /* class binding_key2.  */
 
 const binding_key2 *
-binding_key2::make (store2_manager *mgr, region2 *r, enum kind kind)
+binding_key2::make (store2_manager *mgr, const region2 *r, enum kind kind)
 {
   region_offset offset = r->get_offset ();
   if (offset.symbolic_p ())
@@ -151,7 +151,7 @@ binding_cluster2::operator== (const binding_cluster2 &other) const
     {
       const binding_key2 *key = (*iter).first;
       const svalue2 *sval = (*iter).second;
-      svalue2 **other_slot
+      const svalue2 **other_slot
 	= const_cast <map_t &> (other.m_map).get (key);
       if (other_slot == NULL)
 	return false;
@@ -185,7 +185,7 @@ binding_cluster2::dump_to_pp (pretty_printer *pp, bool simple,
   unsigned i;
   FOR_EACH_VEC_ELT (binding_key2s, i, key)
     {
-      svalue2 *value = *const_cast <map_t &> (m_map).get (key);
+      const svalue2 *value = *const_cast <map_t &> (m_map).get (key);
       if (multiline)
 	{
 	  pp_string (pp, "    key:   {");
@@ -215,7 +215,7 @@ binding_cluster2::dump_to_pp (pretty_printer *pp, bool simple,
 
 void
 binding_cluster2::bind (store2_manager *mgr,
-			region2 *reg, svalue2 *val)
+			const region2 *reg, const svalue2 *val)
 {
   const binding_key2 *binding
     = binding_key2::make (mgr, reg, binding_key2::BK_direct);
@@ -225,7 +225,7 @@ binding_cluster2::bind (store2_manager *mgr,
 /* FIXME.  */
 
 void
-binding_cluster2::clobber_region (store2_manager *mgr, region2 *reg)
+binding_cluster2::clobber_region (store2_manager *mgr, const region2 *reg)
 {
   remove_overlapping_bindings (mgr, reg);
 }
@@ -242,13 +242,13 @@ binding_cluster2::purge_region (store2_manager *mgr, const region2 *reg)
   m_map.remove (binding);
 }
 
-svalue2 *
+const svalue2 *
 binding_cluster2::get_binding (store2_manager *mgr,
-			       region2 *reg,
+			       const region2 *reg,
 			       binding_key2::kind kind) const
 {
   const binding_key2 *binding = binding_key2::make (mgr, reg, kind);
-  svalue2 **slot = const_cast<map_t &> (m_map).get (binding);
+  const svalue2 **slot = const_cast<map_t &> (m_map).get (binding);
   if (slot)
     return *slot;
   return NULL;
@@ -258,7 +258,7 @@ binding_cluster2::get_binding (store2_manager *mgr,
 
 void
 binding_cluster2::get_overlapping_bindings (store2_manager *mgr,
-					    region2 *reg,
+					    const region2 *reg,
 					    auto_vec<const binding_key2 *> *out)
 {
   /* Get the size of REG.  */
@@ -270,7 +270,8 @@ binding_cluster2::get_overlapping_bindings (store2_manager *mgr,
        iter != m_map.end (); ++iter)
     {
       const binding_key2 *iter_key = (*iter).first;
-      if (const concrete_binding2 *ckey = binding->dyn_cast_concrete_binding2 ())
+      if (const concrete_binding2 *ckey
+	    = binding->dyn_cast_concrete_binding2 ())
 	{
 	  if (const concrete_binding2 *iter_ckey
 	      = iter_key->dyn_cast_concrete_binding2 ())
@@ -297,7 +298,7 @@ binding_cluster2::get_overlapping_bindings (store2_manager *mgr,
 
 void
 binding_cluster2::remove_overlapping_bindings (store2_manager *mgr,
-					       region2 *reg)
+					       const region2 *reg)
 {
   auto_vec<const binding_key2 *> bindings;
   get_overlapping_bindings (mgr, reg, &bindings);
@@ -341,14 +342,14 @@ binding_cluster2::redundant_p () const
 
 void
 binding_cluster2::get_representative_path_vars (const region2 *base_reg,
-						svalue2 *sval,
+						const svalue2 *sval,
 						auto_vec<path_var> *out_pvs)
   const
 {
   for (map_t::iterator iter = m_map.begin (); iter != m_map.end (); ++iter)
     {
       const binding_key2 *key = (*iter).first;
-      svalue2 *bound_sval = (*iter).second;
+      const svalue2 *bound_sval = (*iter).second;
       if (bound_sval == sval)
 	{
 	  if (const concrete_binding2 *ckey
@@ -525,21 +526,21 @@ store2::dump_to_pp (pretty_printer *pp, bool summarize, bool multiline) const
     }
 }
 
-svalue2 *
-store2::get_direct_binding (store2_manager *mgr, region2 *reg)
+const svalue2 *
+store2::get_direct_binding (store2_manager *mgr, const region2 *reg)
 {
   return get_binding (mgr, reg, binding_key2::BK_direct);
 }
 
-svalue2 *
-store2::get_default_binding (store2_manager *mgr, region2 *reg)
+const svalue2 *
+store2::get_default_binding (store2_manager *mgr, const region2 *reg)
 {
   return get_binding (mgr, reg, binding_key2::BK_direct);
 }
 
-svalue2 *
+const svalue2 *
 store2::get_binding (store2_manager *mgr,
-		     region2 *reg,
+		     const region2 *reg,
 		     binding_key2::kind kind)
 {
   const region2 *base_reg = reg->get_base_region ();
@@ -550,7 +551,8 @@ store2::get_binding (store2_manager *mgr,
 }
 
 void
-store2::set_value (store2_manager *mgr, region2 *lhs_reg, svalue2 *rhs_sval)
+store2::set_value (store2_manager *mgr, const region2 *lhs_reg,
+		   const svalue2 *rhs_sval)
 {
   remove_overlapping_bindings (mgr, lhs_reg);
 
@@ -571,7 +573,7 @@ store2::set_value (store2_manager *mgr, region2 *lhs_reg, svalue2 *rhs_sval)
 /* FIXME.  */
 
 void
-store2::clobber_region (store2_manager *mgr, region2 *reg)
+store2::clobber_region (store2_manager *mgr, const region2 *reg)
 {
   const region2 *base_reg = reg->get_base_region ();
   binding_cluster2 **slot = m_cluster_map.get (base_reg);
@@ -659,7 +661,7 @@ store2::escaped_p (const region2 *base_reg) const
 /* FIXME.  */
 
 void
-store2::get_representative_path_vars (svalue2 *sval,
+store2::get_representative_path_vars (const svalue2 *sval,
 				      auto_vec<path_var> *out_pvs) const
 {
   gcc_assert (sval);
@@ -677,7 +679,7 @@ store2::get_representative_path_vars (svalue2 *sval,
 /* FIXME.  */
 
 void
-store2::remove_overlapping_bindings (store2_manager *mgr, region2 *reg)
+store2::remove_overlapping_bindings (store2_manager *mgr, const region2 *reg)
 {
   const region2 *base_reg = reg->get_base_region ();
   if (reg == base_reg && !escaped_p (base_reg))
diff --git a/gcc/analyzer/store2.h b/gcc/analyzer/store2.h
index c4c3c8b78c5..5023402a640 100644
--- a/gcc/analyzer/store2.h
+++ b/gcc/analyzer/store2.h
@@ -52,7 +52,7 @@ public:
     return kind == BK_direct ? "direct" : "default";
   }
 
-  static const binding_key2 *make (store2_manager *mgr, region2 *r,
+  static const binding_key2 *make (store2_manager *mgr, const region2 *r,
 				   enum kind kind);
 
   virtual void dump_to_pp (pretty_printer *pp, bool simple) const;
@@ -166,22 +166,23 @@ public:
   void dump_to_pp (pretty_printer *pp, bool simple, bool multiline) const;
 
 #if 1
-  void bind (store2_manager *mgr, region2 *, svalue2 *);
+  void bind (store2_manager *mgr, const region2 *, const svalue2 *);
 #else
   const binding_cluster2 *bind (const extrinsic_state &ext_state,
 			       const region2 *, const svalue2 *) const;
 #endif
 
-  void clobber_region (store2_manager *mgr, region2 *reg);
+  void clobber_region (store2_manager *mgr, const region2 *reg);
   void purge_region (store2_manager *mgr, const region2 *reg);
 
-  svalue2 *get_binding (store2_manager *mgr, region2 *reg,
-			binding_key2::kind kind) const;
+  const svalue2 *get_binding (store2_manager *mgr, const region2 *reg,
+			      binding_key2::kind kind) const;
 
-  void remove_overlapping_bindings (store2_manager *mgr, region2 *reg);
+  void remove_overlapping_bindings (store2_manager *mgr, const region2 *reg);
 
   template <typename T>
-  void for_each_value (void (*cb) (svalue2 *sval, T user_data), T user_data)
+  void for_each_value (void (*cb) (const svalue2 *sval, T user_data),
+		       T user_data)
   {
     for (map_t::iterator iter = m_map.begin (); iter != m_map.end (); ++iter)
       cb ((*iter).second, user_data);
@@ -194,14 +195,14 @@ public:
   bool redundant_p () const;
 
   void get_representative_path_vars (const region2 *base_reg,
-				     svalue2 *sval,
+				     const svalue2 *sval,
 				     auto_vec<path_var> *out_pvs) const;
 
 private:
-  void get_overlapping_bindings (store2_manager *mgr, region2 *reg,
+  void get_overlapping_bindings (store2_manager *mgr, const region2 *reg,
 				 auto_vec<const binding_key2 *> *out);
 
-  typedef hash_map <const binding_key2 *, svalue2 *> map_t;
+  typedef hash_map <const binding_key2 *, const svalue2 *> map_t;
   map_t m_map;
 
   /* Has a pointer to this cluster "escaped" into a part of the program
@@ -232,13 +233,14 @@ public:
 
   void dump_to_pp (pretty_printer *pp, bool summarize, bool multiline) const;
 
-  svalue2 *get_direct_binding (store2_manager *mgr, region2 *reg);
-  svalue2 *get_default_binding (store2_manager *mgr, region2 *reg);
-  svalue2 *get_binding (store2_manager *mgr,
-			region2 *reg, binding_key2::kind kind);
+  const svalue2 *get_direct_binding (store2_manager *mgr, const region2 *reg);
+  const svalue2 *get_default_binding (store2_manager *mgr, const region2 *reg);
+  const svalue2 *get_binding (store2_manager *mgr,
+			      const region2 *reg, binding_key2::kind kind);
 
-  void set_value (store2_manager *mgr, region2 *lhs_reg, svalue2 *rhs_sval);
-  void clobber_region (store2_manager *mgr, region2 *reg);
+  void set_value (store2_manager *mgr, const region2 *lhs_reg,
+		  const svalue2 *rhs_sval);
+  void clobber_region (store2_manager *mgr, const region2 *reg);
   void purge_region (store2_manager *mgr, const region2 *reg);
 
   binding_cluster2 *get_cluster (const region2 *base_reg);
@@ -257,11 +259,11 @@ public:
 
   bool escaped_p (const region2 *reg) const;
 
-  void get_representative_path_vars (svalue2 *sval,
+  void get_representative_path_vars (const svalue2 *sval,
 				     auto_vec<path_var> *out_pvs) const;
 
 private:
-  void remove_overlapping_bindings (store2_manager *mgr, region2 *reg);
+  void remove_overlapping_bindings (store2_manager *mgr, const region2 *reg);
 
   typedef hash_map <const region2 *, binding_cluster2 *> cluster_map_t;
   cluster_map_t m_cluster_map; // TODO: deep copy of this!
-- 
2.26.2

